(* transitions.ml *)
(* Contient des fonctions permettant de trouver des relations sur les variables
 * d’entrée pour le passage entre deux états d’un automate. *)

open Utils
open Syntax
open Automata
open Qelim


let search_entry_conditions aut deb fin =
        let output_prime = List.map Logic_node.prime_of aut.output in
        let input_prime = List.map Logic_node.prime_of aut.input in (* FIXME: Faut-il enlever ces variables, ou les variables normales ? *)
        let prop_deb = make_and aut.states.(deb) in
        let prop_fin = Logic_node.primer (make_and aut.states.(fin)) in
        let trans = make_and
        [
                aut.transition_formula ;
                prop_deb ;
                prop_fin
        ] in
        let t = plonge (convert_to_mjollnir trans) in
        let f = exists aut.output (exists output_prime (exists input_prime t)) in
        let f' = exists aut.local (exists (List.map Logic_node.prime_of aut.local) f) in
        convert_to_expression (elim f')

let compute_conditions automata =
        let foo (deb, fin, _) =
                (deb, fin,
                search_entry_conditions automata deb fin)
        in
        automata.transitions <- List.map foo automata.transitions;
        let create_outprop l =
                let f = plonge (convert_to_mjollnir (make_and l)) in
                let f' = exists (List.map Logic_node.prime_of automata.local) (exists automata.local f) in
                convert_to_expression (elim f')
        in
        automata.output_prop <- Array.map create_outprop automata.states;
        ()

