(* node_action.mli *)
(* Contient la fonction qui travaille à partir des arguments sur un nœud
 * en particulier. *)

type argument =
        {
                mutable input : in_channel;
                mutable output : out_channel;

                mutable verbose : bool;

                mutable read_lustre : bool;
                mutable write_lustre : bool;

                mutable node_to_be_analysed : string option;

                mutable compute_predicates : bool;
                mutable level_predicates : int;
                mutable print_predicates : bool;

                mutable simplify_trivial_equation : bool;
                mutable simplify_if_blocs : bool;
                mutable expand_pre_blocs : bool;

                mutable compute_logic_node : bool;
                mutable print_logic_node : bool;

                mutable find_invariant : bool;
                mutable invariant_options : Invariants.arg;
                mutable print_invariant : bool;

                mutable compute_automata : bool;
                mutable print_automata : bool;
        }

type variables_node =
        {
                mutable node : Syntax.node;
                mutable predicates : Syntax.expression list option;
                mutable logic_transition : Syntax.expression option;
                mutable logic_initialisation : Syntax.expression option;
                mutable invariant : Syntax.expression list list option;
        }


val do_node : argument -> variables_node -> unit

