(* formules.ml *)
(* Contient des fonctions pour manipuler des formules logiques. *)

open Syntax


let rec erase_nor_diese = function
    | Nor, Op l, _ ->
        let rec l_or = function
            | [] -> False, Op [], TBool
            | a :: [] -> a
            | a :: suite -> Or, Op [a ; l_or suite], TBool
        in
        Not, Op [l_or l], TBool
    | Diese, Op l, _ ->
        let rec l_and = function
            | [] -> False, Op [], TBool
            | a :: [] -> a
            | a :: suite -> And, Op [a ; l_and suite], TBool
        in
        Not, Op [l_and l], TBool
    | call, Op l, ty -> call, Op (List.map erase_nor_diese l), ty

