(* context.ml *)
(* Contient des fonctions de manipulations de contextes Yices. *)

open Utils
open Smt
open Syntax
open Yices


let yices_expr = mk_true (mk_context ())
(* Elle ne sert que pour initialiser les types. *)


let get_new_id_context =
    let id = ref 0 in
    fun () -> incr id; !id - 1


let context_bool cont = function
        | true -> mk_true cont
        | false -> mk_false cont

let create_c context m b pi =
    let atome j = (* b_j => pi_j *)
        implique context b.(j) pi.(j)
    in
    mk_and_nsf context (create_list (fun j -> atome (j - 1)) m)

let create_T context n m b pi = (* ajoute la formule \/_i /\ (b_ij => pi_j) dans le contexte C *)
        let c i = create_c context m b.(i - 1) pi
        in
        let l = create_list c n in
        mk_or_nsf context l


let switch_value_in model expr f_true f_false =
    match evaluate_in_model model expr with
    | L_UNKNOWN -> raise Errors.Yices_unknown
    | L_TRUE -> f_true ()
    | L_FALSE -> f_false ()

let model_expr_to_context_bool context model e =
    switch_value_in model e
    (fun () -> mk_true context)
    (fun () -> mk_false context)

