(* context.mli *)
(* Contient des fonctions de manipulations de contextes Yices. *)

val yices_expr : Yices.expr

val get_new_id_context : unit -> int

val context_bool : Yices.context -> bool -> Yices.expr

val create_c : Yices.context -> int -> Yices.expr array -> Yices.expr array -> Yices.expr
(* “create_c context m b pi” va créer /\_j b_j => pi_j *)

val create_T : Yices.context -> int -> int -> Yices.expr array array -> Yices.expr array -> Yices.expr
(* “create_T C n m b pi” ajoute la formule \/_i /\ (b_ij => pi_j) dans le contexte C *)

val switch_value_in : Yices.model -> Yices.expr -> (unit -> 'a) -> (unit -> 'a) -> 'a
(* Suivant la valeur dans le modèle, cette fonction va exécuter la première ou la seconde fonction. *)
val model_expr_to_context_bool : Yices.context -> Yices.model -> Yices.expr -> Yices.expr

