(* POUR FAIRE DES ESSAIS *)

let vvals = Hashtbl.create 50;;

let rec contains lst e = (
	match lst with
		[] -> false
	|	x::t -> if (x = e) then true else (contains t e)
)
let rec uniq_list = ( function 
	[] -> []
|	e::tail -> if (contains tail e)
	           then (uniq_list tail)
	           else e::(uniq_list tail)
)

let rec get_var_vals vardefs var = (
	try (
		try (
			match (Hashtbl.find vvals var) with
			Some res -> res
			|	None -> (
				raise (Internal_error ("get_var_vals", "recursive defs of"^var))
			)
		) with Not_found -> (
			Hashtbl.add vvals var None ;
			let e = Hashtbl.find vardefs var in
			let res = get_exp_vals vardefs e in
			Hashtbl.add vvals var (Some res);
			res
		)
	) with Not_found -> [Syntaxe.make_val_exp (IDENT_n var) [] ]
) and get_exp_vals vardefs e = (
	match e with
	(* feuilles *)
	   (ICONST_n _, _)
	|  (RCONST_n _, _)
	|  (IVAL_n _, _)
	|  (RVAL_n _, _)
	|	(PRE_n, _) -> [e]
	(* ident *)
	|	(IDENT_n id , _) -> get_var_vals vardefs id 
	(* if, ->, when *)
	|	(IF_n, Ops [e0; e1; e2]) ->
		(get_exp_vals vardefs e1) @ (get_exp_vals vardefs e2)
	|	(ARROW_n, Ops [e0; e1]) ->
		(get_exp_vals vardefs e0) @ (get_exp_vals vardefs e1)
	(* op numeriques *)	
	|	(UMINUS_n, Ops [e0]) -> (
		let simpfunc = Hashtbl.find SimpFunc.table UMINUS_n in
		let appsimpfunc (op : Syntaxe.val_exp) = (
			simpfunc [op]
		) in
		List.map appsimpfunc (get_exp_vals vardefs e0)
	)
	|	(MINUS_n as binop, Ops [e0; e1])
	|	(PLUS_n as binop, Ops [e0; e1])
	|	(SLASH_n as binop, Ops [e0; e1])
	|	(TIMES_n as binop, Ops [e0; e1]) -> (
		let simpfunc = Hashtbl.find SimpFunc.table binop in
		let ll0 = get_exp_vals vardefs e0 in
		let ll1 = get_exp_vals vardefs e1 in
printf "merge %d * %d\n" (List.length ll0) (List.length ll1) ;
flush stdout;
		let l0 = uniq_list ll0 in
		let l1 = uniq_list ll1 in
let pexp e = (
	Dump.dump_simple_exp e;
	printf "\n"
) in
printf "====> %d * %d\n" (List.length l0) (List.length l1) ;
printf "***** l0 *******\n" ;
List.map pexp l0;
printf "***** l1 *******\n" ;
List.map pexp l1;
flush stdout;
		(* opere x0 avec tous les lments de l1 *)
		let map_op_l1 (x0 : val_exp) = (
			(* opere x1 avec x0 tous les lments de l1 *)
			let app_op_x0 (x1 : val_exp) = (
				simpfunc [x0; x1]
			) in
			List.map app_op_x0 l1
		) in
		let ll = List.map map_op_l1 l0 in
		List.flatten ll
	)
	(* le reste ignor ... *)
	|	_ -> (
		raise (Internal_error ("get_exp_vals", "unexpected exp"))
	)


)
