(*
Un module au dessus de lexer et parser
pour viter les dpendances boucles
*)

open Lexing
open Printf

(* pour calculer line/col *)
let line_num = ref 1
let line_start_pos = ref 0

let new_line ( lexbuf ) = (
	line_start_pos := Lexing.lexeme_end lexbuf;
	incr line_num;
(* printf "making newline\n"; flush stdout ; *)
	()
)

(* le type ``lexeme'', string + info source *)
type t = { str : string ; line : int ; cstart : int ; cend : int }

(* constructeur de type flagg avec un lexeme *)
type 'a srcflaged = {
   src : t ;
   it  : 'a
}
(* flagage d'une valeur quelconque *) 
let (flagit : 'a -> t -> 'a srcflaged) = 
function x -> function lxm -> 
{ it = x; src = lxm }

let dummy = { str = "dummy" ; line = 0 ; cstart = 0 ; cend = 0 }

let last_lexeme = ref dummy 

let make ( lexbuf ) = (
	let s = (Lexing.lexeme lexbuf) in
   let l = !line_num in
   let c1 = (Lexing.lexeme_start lexbuf - !line_start_pos + 1) in
   let c2 = (Lexing.lexeme_end lexbuf - !line_start_pos) in
   	last_lexeme := { str = s ; line = l; cstart = c1 ; cend = c2 };
		(* printf "making lexeme '%s'\n" s; flush stdout; *)
		!last_lexeme
)


let last_made () = !last_lexeme 
