%{
(*----------------------------------------------------------------

16/07/2004

OBSOLETE => PASSAGE au xec (extended ec, ou Lustre simple au choix ...)

Passage ec -> format interne
----------------------------------------------------------------*)
open Lexing
open Lexeme
open Syntaxe
open Errors
open Format
open Str

(* init parse *)
let const_table = ref (Hashtbl.create 50)
let type_table  = ref (Hashtbl.create 50)
let oper_table  = ref (Hashtbl.create 50)
let def_list    = ref []

let add_info
   (htbl   : (string, 'a srcflaged) Hashtbl.t)
   (kindof : string)   (* une string en cas d'erreur   *)
   (lxm  : Lexeme.t)   (* le lexeme en question        *)
   (info : 'a)         (* l'info en question           *)
= (
   try
      let x  = Hashtbl.find htbl lxm.str in
      raise (
         Compile_error ( lxm ,
            (sprintf "bad %s declaration, ident already linked line %d col %d"
               kindof x.src.line x.src.cstart)
         )
      )
   with Not_found -> (
      Hashtbl.add htbl lxm.str {
         src = lxm ;
         it  = info
      }
   )
)

let add_constant (lxm : Lexeme.t) (ci : const_info) = (
	add_info !const_table "constant" lxm ci ;
	def_list := (ConstDef lxm.str) :: !def_list
) 
let add_type (lxm : Lexeme.t) (ci : type_info) = (
	add_info !type_table "type" lxm ci;
	def_list := (TypeDef lxm.str) :: !def_list
)
let add_oper (lxm : Lexeme.t) (ci : oper_info) = (
	add_info !oper_table "operator" lxm ci;
	def_list := (OperDef lxm.str) :: !def_list
)

%}

%token TK_EOF

%token <Lexeme.t> TK_ERROR

%token <Lexeme.t> TK_AND
%token <Lexeme.t> TK_ARROW
%token <Lexeme.t> TK_ARROW
%token <Lexeme.t> TK_ASSERT
%token <Lexeme.t> TK_BAR
%token <Lexeme.t> TK_BOOL
%token <Lexeme.t> TK_CDOTS
%token <Lexeme.t> TK_CLOSE_BRACE
%token <Lexeme.t> TK_CLOSE_BRACKET
%token <Lexeme.t> TK_CLOSE_PAR
%token <Lexeme.t> TK_COLON
%token <Lexeme.t> TK_COMA
%token <Lexeme.t> TK_CONST
%token <Lexeme.t> TK_CURRENT
%token <Lexeme.t> TK_DIV
%token <Lexeme.t> TK_DOT
%token <Lexeme.t> TK_EQ
%token <Lexeme.t> TK_EQUA
%token <Lexeme.t> TK_ELSE
%token <Lexeme.t> TK_ENUM
%token <Lexeme.t> TK_FALSE
%token <Lexeme.t> TK_FIELD
%token <Lexeme.t> TK_FUNCTION
%token <Lexeme.t> TK_GT
%token <Lexeme.t> TK_GTE
%token <Lexeme.t> TK_HAT
%token <Lexeme.t> TK_HIDDEN
%token <Lexeme.t> TK_ICONST
%token <Lexeme.t> TK_IDENT
%token <Lexeme.t> TK_IF
%token <Lexeme.t> TK_IMPL
%token <Lexeme.t> TK_IMPORTED
%token <Lexeme.t> TK_INT
%token <Lexeme.t> TK_LET
%token <Lexeme.t> TK_LT
%token <Lexeme.t> TK_LTE
%token <Lexeme.t> TK_MINUS
%token <Lexeme.t> TK_MOD
%token <Lexeme.t> TK_NEQ
%token <Lexeme.t> TK_NODE
%token <Lexeme.t> TK_NOR
%token <Lexeme.t> TK_NOT
%token <Lexeme.t> TK_OPEN_BRACE
%token <Lexeme.t> TK_OPEN_BRACKET
%token <Lexeme.t> TK_OPEN_PAR
%token <Lexeme.t> TK_OR
%token <Lexeme.t> TK_PCENT
%token <Lexeme.t> TK_PLUS
%token <Lexeme.t> TK_PRE
%token <Lexeme.t> TK_RCONST
%token <Lexeme.t> TK_REAL
%token <Lexeme.t> TK_RETURNS
%token <Lexeme.t> TK_SEMICOL
%token <Lexeme.t> TK_SLASH
%token <Lexeme.t> TK_STAR
%token <Lexeme.t> TK_TEL
%token <Lexeme.t> TK_THEN
%token <Lexeme.t> TK_TRUE
%token <Lexeme.t> TK_TYPE
%token <Lexeme.t> TK_VAR
%token <Lexeme.t> TK_WHEN
%token <Lexeme.t> TK_XOR
%token <Lexeme.t> TK_CASE
%token <Lexeme.t> TK_OF
%token <Lexeme.t> TK_DEFAULT

/* Priorities */

%left TK_ELSE
%left TK_BAR
%left TK_ARROW
%nonassoc TK_CDOTS
%left TK_OR TK_XOR
%left TK_AND
%nonassoc TK_LT TK_LTE TK_EQ TK_GTE TK_GT TK_NEQ TK_IMPL 
%nonassoc TK_NOT
%left TK_PLUS TK_MINUS
%left TK_STAR TK_SLASH TK_PCENT TK_MOD TK_DIV
%left TK_WHEN
%nonassoc TK_INT TK_REAL
%nonassoc TK_UMINUS TK_PRE TK_CURRENT TK_DIESE TK_NOR
%left TK_HAT TK_FIELD TK_DOT
%right TK_OPEN_BRACKET TK_OPEN_BRACE TK_SEMICOL
%right TK_COMA

/* ecEntry point */
%start ecFile
%type <Syntaxe.package> ecFile

%%

/*-------------------------------------------------------
	GRAMMAR
---------------------------------------------------------
NOTES ON THE CODE:

- Nothing is "build" for the main list declarations :
each definition is directly inserted in the corresponding
hash table (i.e. each declaration makes a side effect)

- Any rule that produces a caml list builds it in THE REVERSE
ORDER (in order to save the yacc stack and to avoid
the use of the caml @ operator). This is why they are
named "sxTotoReverseList". This is why they must not be
used in other rules: onr have to use the corresponding
"sxTotoList" which finally reverse the list.
-------------------------------------------------------*/

/*
WARNING 
La syntaxe ne permet pas de rattacher les bloc equa
a l'entete de node correspondant. On fait donc ca par
effet de bord...
*/

ecFile:
		 ecNodeDecl TK_EOF
	{
			{
      		const_table = !const_table;
      		type_table  = !type_table;
      		oper_table  = !oper_table;
      		def_list    = (List.rev !def_list)
   		}
	}
	|   ecDeclList ecNodeDecl TK_EOF
		{ 
			{
      		const_table = !const_table;
      		type_table  = !type_table;
      		oper_table  = !oper_table;
      		def_list    = (List.rev !def_list)
   		}
		 }
	;

/* ecDeclarations */

ecDeclList:   ecOneDecl
			{ }
	|   ecDeclList ecOneDecl
			{ }
	;

ecOneDecl:
		ecConstDecl
		{ }
	|	ecTypeDecl
		{ }
	|	ecFuncDecl
		{ }
	;


/* ecIdentifiers and lists */
ecIdent : TK_IDENT
	{ $1 }
	;

ecIdentList: ecIdent
			{ [$1.str] }
	|   ecIdentList TK_COMA ecIdent
			{ ($3.str)::$1 }
	;


ecTypedIdent : ecIdent TK_COLON ecType
	{ ($1.str, $3) }
	;

ecFieldList: ecTypedIdent
			{ [$1] }
	|   ecFieldList TK_COMA ecTypedIdent
			{ $3::$1 }
	;

ecTypedIdentList: ecTypedIdent
			{ [$1] }
	|   ecTypedIdentList TK_SEMICOL ecTypedIdent
			{ $3::$1 }
	;


/* constantes */

ecConstDecl:
	TK_CONST ecConstDeclList TK_SEMICOL
			{}
	| TK_CONST ecConstDeclList TK_DOT
			{}
	;

ecConstDeclList:   ecOneConstDecl
			{}
	|   ecConstDeclList TK_SEMICOL ecOneConstDecl
			{}
	;

ecOneConstDecl: 
	   /* imported */
		ecIdent TK_COLON ecType
			{ add_constant $1 (ExternalConst ($1.str, $3)) }
	; 

/* types */

ecTypeDecl: 
	TK_TYPE ecTypeDeclList TK_SEMICOL
			{}
	| TK_TYPE ecTypeDeclList TK_DOT
			{}
	;

ecTypeDeclList:   ecOneTypeDecl 
			{}
	|   ecTypeDeclList TK_COMA ecOneTypeDecl
			{}
	;

ecOneTypeDecl:
		/* imported type */
		ecIdent
			{ add_type $1 (ExternalType $1.str) }
	;

/* Immediate type */
ecType:
		/* predefined */
		ecPredefinedType
			{ $1 }
		/* named */
	|	ecIdent
			{ (NamedType $1.str) }
	;

ecTypeList:
		ecType
			{ [$1] }
	|	ecTypeList TK_COMA ecType
			{ $3::$1 }
	;

ecPredefinedType:
	   TK_BOOL 
			{ Bool }
	|   TK_INT 
			{ Int }
	|   TK_REAL
			{ Real }
	;


/* functions (imported nodes) */

ecFuncDecl: 
				TK_FUNCTION ecIdent
            TK_OPEN_PAR ecTypedIdentList TK_CLOSE_PAR
				TK_RETURNS TK_OPEN_PAR ecTypedIdentList TK_CLOSE_PAR ecOptEnding
	{ 
		let finfo = {
			fi_name = $2.str;
			fi_inpars = (List.rev $4);
			fi_outpars = (List.rev $8);
		} in
		(add_oper $2 (FuncOper finfo))
	}
	;


/* defined nodes */

ecNodeDecl:
	TK_NODE ecIdent 
	TK_OPEN_PAR ecVarDeclList TK_CLOSE_PAR
	TK_RETURNS TK_OPEN_PAR ecVarDeclList TK_CLOSE_PAR TK_SEMICOL
   ecLocals ecNodeBody
	{
		let ninfo = {
			ni_name = $2.str ;
			ni_inputs = List.rev $4 ;
			ni_outputs = List.rev $8 ;
			ni_locals = List.rev $11 ;
			ni_asserts = List.rev (fst $12) ;
			ni_defs = List.rev (snd $12)
		} in (add_oper $2 (NodeOper ninfo))
	}
	;

ecVarDeclList:
		ecVarDecl
			{ [$1] }
	|	ecVarDeclList TK_SEMICOL ecVarDecl
			{ $3::$1 }
	;

ecVarDecl:
		ecTypedIdent
			{ (fst $1, snd $1, BaseClock) }
	|	ecTypedIdent TK_WHEN ecIdent
			{ (fst $1, snd $1, NamedClock $3.str) }
	;

ecLocals:	/* empty */
			{ [] }
	|    TK_VAR  TK_SEMICOL
			{ [] }
	|    TK_VAR ecVarDeclList TK_SEMICOL
			{ $2 }
	;

/* node body :
	renvoie un couple (liste d'assert, liste d'equa)
*/

ecNodeBody :
  TK_LET ecEquationList TK_TEL ecOptEnding
			 { $2 }
	;

ecOptEnding :
		/* empty */ {} | TK_SEMICOL {} | TK_DOT {}
	;

/* equations */

ecEquationList:   ecEquation
			{ $1 }
	|   ecEquationList ecEquation
			{ ((fst $2)@(fst $1), (snd $2)@(snd $1)) }
	;

ecEquation:   TK_ASSERT ecExpression TK_SEMICOL
			{ ([$2], []) }
	|   ecLeft TK_EQ ecExpression TK_SEMICOL
			{ ([], [(List.rev $1, $3)]) }
	;

/* left part : non-empty list of idents */

ecLeft:	   ecLeftItemList
		{ $1 }
	;

ecLeftItemList:   ecLeftItem
			{ [$1] }
	|   ecLeftItemList TK_COMA ecLeftItem 
			{ $3::$1 }
	;

ecLeftItem:
		ecIdent
		{ (LeftVar $1.str) }
	;


/* expression */

ecExpression: 
	   ecConstant
			{ make_val_exp $1 [] }
	|   ecIdent 
			{ make_val_exp (IDENT_n $1.str) [] }
	|   TK_NOT ecExpression
			{ make_val_exp NOT_n [$2] }
	|   TK_MINUS ecExpression %prec TK_UMINUS
			{ make_val_exp UMINUS_n [$2] }
	|   TK_PRE ecExpression
			{ make_val_exp PRE_n [$2] }
	|   TK_CURRENT ecExpression
			{ make_val_exp CURRENT_n [$2] }
	|   TK_INT ecExpression 
			{ make_val_exp REAL2INT_n [$2] }
	|   TK_REAL ecExpression 
			{ make_val_exp INT2REAL_n [$2] }
	|  ecExpression TK_ARROW ecExpression
			{ make_val_exp ARROW_n [$1; $3] }
	|  ecExpression TK_WHEN ecExpression
			{ make_val_exp WHEN_n [$1; $3] }
	|  TK_IF ecExpression TK_THEN ecExpression TK_ELSE ecExpression
			{ make_val_exp IF_n [$2; $4; $6] }
	|  ecExpression TK_XOR ecExpression
			{ make_val_exp XOR_n [$1;$3] }
	|  ecExpression TK_IMPL ecExpression
			{ make_val_exp IMPL_n [$1;$3] }
	|  ecExpression TK_OR ecExpression
			{ make_val_exp OR_n [$1;$3] }
	|  ecExpression TK_AND ecExpression
			{ make_val_exp AND_n [$1;$3] }
	|  ecExpression TK_EQ ecExpression
			{ make_val_exp EQ_n [$1;$3] }
	|  ecExpression TK_NEQ ecExpression
			{ make_val_exp NEQ_n [$1;$3] }
	|  ecExpression TK_LT ecExpression
			{ make_val_exp LT_n [$1;$3] }
	|  ecExpression TK_LTE ecExpression
			{ make_val_exp LTE_n [$1;$3] }
	|  ecExpression TK_GT ecExpression
			{ make_val_exp GT_n [$1;$3] }
	|  ecExpression TK_GTE ecExpression
			{ make_val_exp GTE_n [$1;$3] }
	|  ecExpression TK_STAR ecExpression
			{ make_val_exp TIMES_n [$1;$3] }
	|  ecExpression TK_SLASH ecExpression
			{ make_val_exp SLASH_n [$1;$3] }
	|  ecExpression TK_MOD ecExpression
			{ make_val_exp MOD_n [$1;$3] }
	|  ecExpression TK_DIV ecExpression
			{ make_val_exp DIV_n [$1;$3] }
	|  ecExpression TK_PLUS ecExpression
			{ make_val_exp PLUS_n [$1;$3] }
	|  ecExpression TK_MINUS ecExpression
			{ make_val_exp MINUS_n [$1;$3] }
	|	ecCallExpression 
			{ $1 }
	/* Simple parenthses */
	|  TK_OPEN_PAR ecExpression TK_CLOSE_PAR
			{ $2 }
	/* Au moins 2 exp => tuple */
	|  TK_OPEN_PAR ecExpList2 TK_CLOSE_PAR
		{ make_val_exp TUPLE_n (List.rev $2) }
	;

/* call */
ecCallExpression:
	ecIdent TK_OPEN_PAR ecExpList TK_CLOSE_PAR
	{ (make_val_exp (CALL_n $1.str) (List.rev $3)) }
	;

ecConstant:
		TK_TRUE
			{ TRUE_n }
	|   TK_FALSE
			{ FALSE_n }
	|    TK_ICONST 
			{ ICONST_n $1.str }
	|   TK_RCONST
			{ RCONST_n $1.str }
	;

/* 0 ou + exps */
ecExpList:
		/* empty */
			{ [] }
	|   ecExpList1 
			{ $1 }
	;
/* >= 1 exps */
ecExpList1:
		ecExpression
			{ [$1] }
	|   ecExpList2 
			{ $1 }
	;

/* >= 2 exps */
ecExpList2: 
	ecExpList1 TK_COMA ecExpression 
			{ $3::$1 }
	;
