(*
Un module au dessus de lexer et parser
pour viter les dpendances boucles
*)

open Lexing

(* pour calculer line/col *)
let line_num = ref 1
let line_start_pos = ref 0

let new_line ( lexbuf ) = (
	line_start_pos := Lexing.lexeme_end lexbuf;
	incr line_num;
	()
)

type src_info = { line : int ; cstart : int ; cend : int }

let get_src_info ( lexbuf ) = (
   let l = !line_num in
   let c1 = (Lexing.lexeme_start lexbuf - !line_start_pos) in
   let c2 = (Lexing.lexeme_end lexbuf - !line_start_pos) in
   { line = l; cstart = c1 ; cend = c2 }
)

